##parameters=type

type = getattr(context.portal_types, type)

if hasattr(context.aq_parent, 'portal_type'):
    fldr = getattr(context.portal_types, context.aq_parent.portal_type)
else:  
    fldr = getattr(context.portal_types, context.portal_type)
    
reasons = []
app = reasons.append
typeInfo = context.portal_types.getTypeInfo(context)

if not type.globalAllow():
    app("""This object is not globally addable, so it's up to the containing folder to allow this object to be added. Alter: implicitly addable""")

if fldr.allowed_content_types and type.portal_type not in fldr.allowed_content_types:
    app("""This containing folder, of type "%s" does not allow this object to be added, it only allows %s. Alter: allowed content types""" % (fldr.portal_type, fldr.allowed_content_types))

if not type.isConstructionAllowed(context):
    app("""Construction of this object type is not allowed for one of the following reasons. This could be on purpose, so please tread with care - not all objects can be added from the drop down menu.""")

if not type.product:
    app("""No product name for this type. Alter: product name.""")

if not type.factory:
    app("""No product factory method for this type. Alter: product factory method.""")

verboseSecurity = 'VerboseSecurity' in context.Control_Panel.Products.objectIds()

try:
    if type.product and type.factory:
        p = context.manage_addProduct[type.product]
        m = getattr(p, type.factory, None)
        if m is None:
            app("""No factory for this type after trying.""")
        try:
            # validate() can either raise Unauthorized or return 0 to
            # mean unauthorized.
            if getSecurityManager().validate(p, p, context.factory, m):
                app("""Security Manager says you aren't allowed to add this product""")
        except Unauthorized, msg:
            app("""Security Manager says you aren't allowed to add this product""")
except AttributeError:
   app("""The product, %s is not registered properly. Alter: product id or folder""" % type.product)

except:
    # its debugging code only, we can live with this :)
   pass
    
return reasons
